import { Align, Direction, Display, FlexDirection, Justify, Node, Overflow, PositionType, Wrap } from 'yoga-layout/load';
export declare const Yoga: import("yoga-layout/load").Yoga;
declare function createYogaNode(): Node;
declare function computeAndLayout(node: any): void;
type FlexAlignType = 'flex-start' | 'flex-end' | 'center' | 'stretch' | 'baseline';
type DimensionValue = number | 'auto' | `${number}%` | null;
export interface FlexStyle {
    alignContent?: 'flex-start' | 'flex-end' | 'center' | 'stretch' | 'space-between' | 'space-around' | undefined;
    alignItems?: FlexAlignType | undefined;
    alignSelf?: 'auto' | FlexAlignType | undefined;
    aspectRatio?: number | string | undefined;
    borderBottomWidth?: number | undefined;
    borderEndWidth?: number | undefined;
    borderLeftWidth?: number | undefined;
    borderRightWidth?: number | undefined;
    borderStartWidth?: number | undefined;
    borderTopWidth?: number | undefined;
    borderWidth?: number | undefined;
    bottom?: DimensionValue | undefined;
    display?: 'none' | 'flex' | undefined;
    end?: DimensionValue | undefined;
    flex?: number | undefined;
    flexBasis?: DimensionValue | undefined;
    flexDirection?: 'row' | 'column' | 'row-reverse' | 'column-reverse' | undefined;
    rowGap?: number | undefined;
    gap?: number | undefined;
    columnGap?: number | undefined;
    flexGrow?: number | undefined;
    flexShrink?: number | undefined;
    flexWrap?: 'wrap' | 'nowrap' | 'wrap-reverse' | undefined;
    height?: DimensionValue | undefined;
    justifyContent?: 'flex-start' | 'flex-end' | 'center' | 'space-between' | 'space-around' | 'space-evenly' | undefined;
    left?: DimensionValue | undefined;
    margin?: DimensionValue | undefined;
    marginBlock?: DimensionValue | undefined;
    marginBlockEnd?: DimensionValue | undefined;
    marginBlockStart?: DimensionValue | undefined;
    marginBottom?: DimensionValue | undefined;
    marginEnd?: DimensionValue | undefined;
    marginHorizontal?: DimensionValue | undefined;
    marginInline?: DimensionValue | undefined;
    marginInlineEnd?: DimensionValue | undefined;
    marginInlineStart?: DimensionValue | undefined;
    marginLeft?: DimensionValue | undefined;
    marginRight?: DimensionValue | undefined;
    marginStart?: DimensionValue | undefined;
    marginTop?: DimensionValue | undefined;
    marginVertical?: DimensionValue | undefined;
    maxHeight?: DimensionValue | undefined;
    maxWidth?: DimensionValue | undefined;
    minHeight?: DimensionValue | undefined;
    minWidth?: DimensionValue | undefined;
    overflow?: 'visible' | 'hidden' | 'scroll' | undefined;
    padding?: DimensionValue | undefined;
    paddingBottom?: DimensionValue | undefined;
    paddingBlock?: DimensionValue | undefined;
    paddingBlockEnd?: DimensionValue | undefined;
    paddingBlockStart?: DimensionValue | undefined;
    paddingEnd?: DimensionValue | undefined;
    paddingHorizontal?: DimensionValue | undefined;
    paddingInline?: DimensionValue | undefined;
    paddingInlineEnd?: DimensionValue | undefined;
    paddingInlineStart?: DimensionValue | undefined;
    paddingLeft?: DimensionValue | undefined;
    paddingRight?: DimensionValue | undefined;
    paddingStart?: DimensionValue | undefined;
    paddingTop?: DimensionValue | undefined;
    paddingVertical?: DimensionValue | undefined;
    position?: 'absolute' | 'relative' | 'static' | undefined;
    right?: DimensionValue | undefined;
    start?: DimensionValue | undefined;
    top?: DimensionValue | undefined;
    width?: DimensionValue | undefined;
    zIndex?: number | undefined;
    /**
  
         * @platform ios
  
         */
    direction?: 'inherit' | 'ltr' | 'rtl' | undefined;
}
export type YogaNode = Node;
export type YogaNodeLayout = {
    left: number;
    right: number;
    top: number;
    bottom: number;
    width: number;
    height: number;
};
export declare const Layout: {
    createYogaNode: typeof createYogaNode;
    ConvertToYogaValue: {
        alignContent: (value: FlexStyle["alignContent"]) => Align | undefined;
        alignItems: (value: FlexStyle["alignItems"]) => Align | undefined;
        alignSelf: (value: FlexStyle["alignSelf"]) => Align | undefined;
        aspectRatio: (value: FlexStyle["aspectRatio"]) => number | undefined;
        borderBottomWidth: (value: FlexStyle["borderBottomWidth"]) => number | undefined;
        borderEndWidth: (value: FlexStyle["borderEndWidth"]) => number | undefined;
        borderLeftWidth: (value: FlexStyle["borderLeftWidth"]) => number | undefined;
        borderRightWidth: (value: FlexStyle["borderRightWidth"]) => number | undefined;
        borderStartWidth: (value: FlexStyle["borderStartWidth"]) => number | undefined;
        borderTopWidth: (value: FlexStyle["borderTopWidth"]) => number | undefined;
        borderWidth: (value: FlexStyle["borderWidth"]) => number | undefined;
        bottom: (value: FlexStyle["bottom"]) => DimensionValue | undefined;
        display: (value: FlexStyle["display"]) => Display | undefined;
        end: (value: FlexStyle["end"]) => DimensionValue | undefined;
        flex: (value: FlexStyle["flex"]) => number | undefined;
        flexBasis: (value: FlexStyle["flexBasis"]) => DimensionValue | undefined;
        flexDirection: (value: FlexStyle["flexDirection"]) => FlexDirection | undefined;
        rowGap: (value: FlexStyle["rowGap"]) => number | undefined;
        gap: (value: FlexStyle["gap"]) => number | undefined;
        columnGap: (value: FlexStyle["columnGap"]) => number | undefined;
        flexGrow: (value: FlexStyle["flexGrow"]) => number | undefined;
        flexShrink: (value: FlexStyle["flexShrink"]) => number | undefined;
        flexWrap: (value: FlexStyle["flexWrap"]) => Wrap | undefined;
        height: (value: FlexStyle["height"]) => DimensionValue | undefined;
        justifyContent: (value: FlexStyle["justifyContent"]) => Justify | undefined;
        left: (value: FlexStyle["left"]) => DimensionValue | undefined;
        margin: (value: FlexStyle["margin"]) => DimensionValue | undefined;
        marginBlock: (value: FlexStyle["marginBlock"]) => DimensionValue | undefined;
        marginBlockEnd: (value: FlexStyle["marginBlockEnd"]) => DimensionValue | undefined;
        marginBlockStart: (value: FlexStyle["marginBlockStart"]) => DimensionValue | undefined;
        marginBottom: (value: FlexStyle["marginBottom"]) => DimensionValue | undefined;
        marginEnd: (value: FlexStyle["marginEnd"]) => DimensionValue | undefined;
        marginHorizontal: (value: FlexStyle["marginHorizontal"]) => DimensionValue | undefined;
        marginInline: (value: FlexStyle["marginInline"]) => DimensionValue | undefined;
        marginInlineEnd: (value: FlexStyle["marginInlineEnd"]) => DimensionValue | undefined;
        marginInlineStart: (value: FlexStyle["marginInlineStart"]) => DimensionValue | undefined;
        marginLeft: (value: FlexStyle["marginLeft"]) => DimensionValue | undefined;
        marginRight: (value: FlexStyle["marginRight"]) => DimensionValue | undefined;
        marginStart: (value: FlexStyle["marginStart"]) => DimensionValue | undefined;
        marginTop: (value: FlexStyle["marginTop"]) => DimensionValue | undefined;
        marginVertical: (value: FlexStyle["marginVertical"]) => DimensionValue | undefined;
        maxHeight: (value: FlexStyle["maxHeight"]) => DimensionValue | undefined;
        maxWidth: (value: FlexStyle["maxWidth"]) => DimensionValue | undefined;
        minHeight: (value: FlexStyle["minHeight"]) => DimensionValue | undefined;
        minWidth: (value: FlexStyle["minWidth"]) => DimensionValue | undefined;
        overflow: (value: FlexStyle["overflow"]) => Overflow | undefined;
        padding: (value: FlexStyle["padding"]) => DimensionValue | undefined;
        paddingBottom: (value: FlexStyle["paddingBottom"]) => DimensionValue | undefined;
        paddingBlock: (value: FlexStyle["paddingBlock"]) => DimensionValue | undefined;
        paddingBlockEnd: (value: FlexStyle["paddingBlockEnd"]) => DimensionValue | undefined;
        paddingBlockStart: (value: FlexStyle["paddingBlockStart"]) => DimensionValue | undefined;
        paddingEnd: (value: FlexStyle["paddingEnd"]) => DimensionValue | undefined;
        paddingHorizontal: (value: FlexStyle["paddingHorizontal"]) => DimensionValue | undefined;
        paddingInline: (value: FlexStyle["paddingInline"]) => DimensionValue | undefined;
        paddingInlineEnd: (value: FlexStyle["paddingInlineEnd"]) => DimensionValue | undefined;
        paddingInlineStart: (value: FlexStyle["paddingInlineStart"]) => DimensionValue | undefined;
        paddingLeft: (value: FlexStyle["paddingLeft"]) => DimensionValue | undefined;
        paddingRight: (value: FlexStyle["paddingRight"]) => DimensionValue | undefined;
        paddingStart: (value: FlexStyle["paddingStart"]) => DimensionValue | undefined;
        paddingTop: (value: FlexStyle["paddingTop"]) => DimensionValue | undefined;
        paddingVertical: (value: FlexStyle["paddingVertical"]) => DimensionValue | undefined;
        position: (value: FlexStyle["position"]) => PositionType | undefined;
        right: (value: FlexStyle["right"]) => DimensionValue | undefined;
        start: (value: FlexStyle["start"]) => DimensionValue | undefined;
        top: (value: FlexStyle["top"]) => DimensionValue | undefined;
        width: (value: FlexStyle["width"]) => DimensionValue | undefined;
        direction: (value: FlexStyle["direction"]) => Direction | undefined;
    };
    ConvertFromYogaValue: {
        alignContent: (value: Align) => FlexStyle["alignContent"];
        alignItems: (value: Align) => FlexStyle["alignItems"];
        alignSelf: (value: Align) => FlexStyle["alignSelf"];
        aspectRatio: (value: number) => FlexStyle["aspectRatio"];
        borderBottomWidth: (value: number) => FlexStyle["borderBottomWidth"];
        borderEndWidth: (value: number) => FlexStyle["borderEndWidth"];
        borderLeftWidth: (value: number) => FlexStyle["borderLeftWidth"];
        borderRightWidth: (value: number) => FlexStyle["borderRightWidth"];
        borderStartWidth: (value: number) => FlexStyle["borderStartWidth"];
        borderTopWidth: (value: number) => FlexStyle["borderTopWidth"];
        borderWidth: (value: number) => FlexStyle["borderWidth"];
        bottom: (value: DimensionValue) => FlexStyle["bottom"];
        display: (value: Display) => FlexStyle["display"];
        end: (value: DimensionValue) => FlexStyle["end"];
        flex: (value: number) => FlexStyle["flex"];
        flexBasis: (value: DimensionValue) => FlexStyle["flexBasis"];
        flexDirection: (value: FlexDirection) => FlexStyle["flexDirection"];
        rowGap: (value: number) => FlexStyle["rowGap"];
        gap: (value: number) => FlexStyle["gap"];
        columnGap: (value: number) => FlexStyle["columnGap"];
        flexGrow: (value: number) => FlexStyle["flexGrow"];
        flexShrink: (value: number) => FlexStyle["flexShrink"];
        flexWrap: (value: Wrap) => FlexStyle["flexWrap"];
        height: (value: DimensionValue) => FlexStyle["height"];
        justifyContent: (value: Justify) => FlexStyle["justifyContent"];
        left: (value: DimensionValue) => FlexStyle["left"];
        margin: (value: DimensionValue) => FlexStyle["margin"];
        marginBlock: (value: DimensionValue) => FlexStyle["marginBlock"];
        marginBlockEnd: (value: DimensionValue) => FlexStyle["marginBlockEnd"];
        marginBlockStart: (value: DimensionValue) => FlexStyle["marginBlockStart"];
        marginBottom: (value: DimensionValue) => FlexStyle["marginBottom"];
        marginEnd: (value: DimensionValue) => FlexStyle["marginEnd"];
        marginHorizontal: (value: DimensionValue) => FlexStyle["marginHorizontal"];
        marginInline: (value: DimensionValue) => FlexStyle["marginInline"];
        marginInlineEnd: (value: DimensionValue) => FlexStyle["marginInlineEnd"];
        marginInlineStart: (value: DimensionValue) => FlexStyle["marginInlineStart"];
        marginLeft: (value: DimensionValue) => FlexStyle["marginLeft"];
        marginRight: (value: DimensionValue) => FlexStyle["marginRight"];
        marginStart: (value: DimensionValue) => FlexStyle["marginStart"];
        marginTop: (value: DimensionValue) => FlexStyle["marginTop"];
        marginVertical: (value: DimensionValue) => FlexStyle["marginVertical"];
        maxHeight: (value: DimensionValue) => FlexStyle["maxHeight"];
        maxWidth: (value: DimensionValue) => FlexStyle["maxWidth"];
        minHeight: (value: DimensionValue) => FlexStyle["minHeight"];
        minWidth: (value: DimensionValue) => FlexStyle["minWidth"];
        overflow: (value: Overflow) => FlexStyle["overflow"];
        padding: (value: DimensionValue) => FlexStyle["padding"];
        paddingBottom: (value: DimensionValue) => FlexStyle["paddingBottom"];
        paddingBlock: (value: DimensionValue) => FlexStyle["paddingBlock"];
        paddingBlockEnd: (value: DimensionValue) => FlexStyle["paddingBlockEnd"];
        paddingBlockStart: (value: DimensionValue) => FlexStyle["paddingBlockStart"];
        paddingEnd: (value: DimensionValue) => FlexStyle["paddingEnd"];
        paddingHorizontal: (value: DimensionValue) => FlexStyle["paddingHorizontal"];
        paddingInline: (value: DimensionValue) => FlexStyle["paddingInline"];
        paddingInlineEnd: (value: DimensionValue) => FlexStyle["paddingInlineEnd"];
        paddingInlineStart: (value: DimensionValue) => FlexStyle["paddingInlineStart"];
        paddingLeft: (value: DimensionValue) => FlexStyle["paddingLeft"];
        paddingRight: (value: DimensionValue) => FlexStyle["paddingRight"];
        paddingStart: (value: DimensionValue) => FlexStyle["paddingStart"];
        paddingTop: (value: DimensionValue) => FlexStyle["paddingTop"];
        paddingVertical: (value: DimensionValue) => FlexStyle["paddingVertical"];
        position: (value: PositionType) => FlexStyle["position"];
        right: (value: DimensionValue) => FlexStyle["right"];
        start: (value: DimensionValue) => FlexStyle["start"];
        top: (value: DimensionValue) => FlexStyle["top"];
        width: (value: DimensionValue) => FlexStyle["width"];
        direction: (value: Direction) => FlexStyle["direction"];
    };
    propertiesList: (keyof FlexStyle)[];
    computeAndLayout: typeof computeAndLayout;
    Setters: {
        alignContent(yogaNode: YogaNode, alignContent: Align): void;
        alignItems(yogaNode: YogaNode, alignItems: Align): void;
        alignSelf(yogaNode: YogaNode, alignSelf: Align): void;
        aspectRatio(yogaNode: YogaNode, aspectRatio: number | undefined): void;
        borderLeftWidth(yogaNode: YogaNode, borderWidth: number | undefined): void;
        borderRightWidth(yogaNode: YogaNode, borderWidth: number | undefined): void;
        borderTopWidth(yogaNode: YogaNode, borderWidth: number | undefined): void;
        borderBottomWidth(yogaNode: YogaNode, borderWidth: number | undefined): void;
        borderWidth(yogaNode: YogaNode, borderWidth: number | undefined): void;
        direction(yogaNode: YogaNode, direction: Direction): void;
        display(yogaNode: YogaNode, display: Display): void;
        flex(yogaNode: YogaNode, flex: number | undefined): void;
        flexBasis(yogaNode: YogaNode, flexBasis: number | "auto" | `${number}%` | undefined): void;
        flexBasisAuto(yogaNode: YogaNode): void;
        flexDirection(yogaNode: YogaNode, flexDirection: FlexDirection): void;
        flexGrow(yogaNode: YogaNode, flexGrow: number | undefined): void;
        flexShrink(yogaNode: YogaNode, flexShrink: number | undefined): void;
        flexWrap(yogaNode: YogaNode, flexWrap: Wrap): void;
        width(yogaNode: YogaNode, height: number | "auto" | `${number}%` | undefined): void;
        height(yogaNode: YogaNode, height: number | "auto" | `${number}%` | undefined): void;
        justifyContent(yogaNode: YogaNode, justifyContent: Justify): void;
        gap(yogaNode: YogaNode, gapLength: number | `${number}%` | undefined): void;
        rowGap(yogaNode: YogaNode, gapLength: number | `${number}%` | undefined): void;
        columnGap(yogaNode: YogaNode, gapLength: number | `${number}%` | undefined): void;
        marginLeft(yogaNode: YogaNode, margin: number | "auto" | `${number}%` | undefined): void;
        marginRight(yogaNode: YogaNode, margin: number | "auto" | `${number}%` | undefined): void;
        marginTop(yogaNode: YogaNode, margin: number | "auto" | `${number}%` | undefined): void;
        marginBottom(yogaNode: YogaNode, margin: number | "auto" | `${number}%` | undefined): void;
        maxHeight(yogaNode: YogaNode, maxHeight: number | `${number}%` | undefined): void;
        maxWidth(yogaNode: YogaNode, maxWidth: number | `${number}%` | undefined): void;
        minHeight(yogaNode: YogaNode, minHeight: number | `${number}%` | undefined): void;
        minWidth(yogaNode: YogaNode, minWidth: number | `${number}%` | undefined): void;
        overflow(yogaNode: YogaNode, overflow: Overflow): void;
        paddingLeft(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        paddingRight(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        paddingTop(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        paddingBottom(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        padding(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        top(yogaNode: YogaNode, top: number | `${number}%` | undefined): void;
        left(yogaNode: YogaNode, left: number | `${number}%` | undefined): void;
        right(yogaNode: YogaNode, right: number | `${number}%` | undefined): void;
        bottom(yogaNode: YogaNode, bottom: number | `${number}%` | undefined): void;
        end(yogaNode: YogaNode, end: number | `${number}%` | undefined): void;
        start(yogaNode: YogaNode, start: number | `${number}%` | undefined): void;
        marginBlock(yogaNode: YogaNode, margin: number | `${number}%` | undefined): void;
        marginBlockEnd(yogaNode: YogaNode, margin: number | `${number}%` | undefined): void;
        marginBlockStart(yogaNode: YogaNode, margin: number | `${number}%` | undefined): void;
        paddingBlock(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        paddingBlockEnd(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        paddingBlockStart(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        paddingHorizontal(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        paddingVertical(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
        marginVertical(yogaNode: YogaNode, margin: number | `${number}%` | undefined): void;
        marginHorizontal(yogaNode: YogaNode, margin: number | `${number}%` | undefined): void;
        marginStart(yogaNode: YogaNode, margin: number | `${number}%` | undefined): void;
        marginEnd(yogaNode: YogaNode, margin: number | `${number}%` | undefined): void;
        paddingStart(yogaNode: YogaNode, padding: number | `${number}%` | undefined): void;
    };
};
export {};
