var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NativeButton_1;
import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
export class ButtonClickEvent extends Event {
    constructor(state, eventDict) {
        super('click', eventDict);
        this.state = state;
    }
}
let NativeButton = NativeButton_1 = class NativeButton extends NSButton {
    static initWithOwner(owner) {
        const button = NativeButton_1.new();
        button._owner = owner;
        return button;
    }
    clicked(_id) {
        const owner = this._owner?.deref();
        if (owner) {
            owner.dispatchEvent(new ButtonClickEvent(this.state === NSOnState));
        }
    }
    setTitle(title) {
        this._title = title;
        this.updateButtonTitleStyle();
    }
    setTitleColor(color) {
        this._color = color;
        this.updateButtonTitleStyle();
    }
    updateButtonTitleStyle() {
        if (!this._attributedTitle) {
            this._attributedTitle = NSMutableAttributedString.alloc().init();
        }
        this._attributedTitle.mutableString.setString(this._title || '');
        this._attributedTitle.setAttributesRange({
            [NSForegroundColorAttributeName]: this._color,
        }, { location: 0, length: this._title?.length || 0 });
        this.attributedTitle = this._attributedTitle;
    }
};
NativeButton.ObjCExposedMethods = {
    clicked: { returns: interop.types.void, params: [interop.types.id] },
};
NativeButton = NativeButton_1 = __decorate([
    NativeClass
], NativeButton);
export { NativeButton };
//# sourceMappingURL=native-button.js.map