import '@nativescript/macos-node-api';
import type { YogaNodeLayout } from '../../layout/index.js';
import { ViewBase } from '../view/view-base.js';
import { Event } from '../../dom/dom-utils.js';
export declare class ImageLoadEvent extends Event {
    constructor(eventDict?: EventInit);
}
export declare class ImageErrorEvent extends Event {
    constructor(eventDict?: EventInit);
}
export type ImageStretch = 'none' | 'fit' | 'fill' | 'aspectFit';
export declare class Image extends ViewBase {
    nativeView?: NSImageView;
    get isLeaf(): boolean;
    initNativeView(): NSImageView | undefined;
    disposeNativeView(): void;
    private setImage;
    src: string | URL;
    symbol: string;
    stretch: ImageStretch;
    applyLayout(parentLayout?: YogaNodeLayout): void;
}
