import "@nativescript/macos-node-api";
import { Event } from "../../dom/dom-utils.js";
import { TableCell } from "../table/table-cell.js";
import { View } from "../view/view.js";
export declare class OutlineClickEvent extends Event {
    index: number;
    constructor(index: number, eventDict?: EventInit);
}
declare class OutlineViewDataSource extends NSObject implements NSOutlineViewDataSource, NSOutlineViewDelegate {
    static ObjCProtocols: (typeof NSOutlineViewDataSource | typeof NSOutlineViewDelegate)[];
    static initWithOwner(owner: WeakRef<Outline>): OutlineViewDataSource;
    _owner?: WeakRef<Outline>;
    get outline(): Outline | undefined;
    outlineViewNumberOfChildrenOfItem(_outlineView: NSOutlineView, item: View | null): number;
    outlineViewViewForTableColumnItem(_outlineView: NSOutlineView, _tableColumn: NSTableColumn | null, item: TableCell): NSView;
    outlineViewIsItemExpandable(_outlineView: NSOutlineView, item: View): boolean;
    outlineViewChildOfItem(_outlineView: NSOutlineView, index: number, item: View | null): Element;
    outlineViewObjectValueForTableColumnByItem(_outlineView: NSOutlineView, _tableColumn: NSTableColumn | null, item: interop.Object | null): any;
    outlineViewSelectionDidChange(notification: NSNotification): void;
}
export declare class Outline extends View {
    nativeView?: NSOutlineView;
    dataSource: OutlineViewDataSource;
    initNativeView(): NSOutlineView | undefined;
    identationPerLevel: number;
    rowSizeStyle: (typeof NSTableViewRowSizeStyle)[keyof typeof NSTableViewRowSizeStyle];
    addNativeChild(_child: any): void;
    removeNativeChild(_child: any): void;
    private __pendingCellSelection;
    expandParentsOfItem(item: TableCell): void;
    selectCell(cell: TableCell): void;
}
export {};
