var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import "@nativescript/macos-node-api";
import { native } from "../decorators/native.js";
import { view } from "../decorators/view.js";
import { ViewBase } from "../view/view-base.js";
let TableCell = class TableCell extends ViewBase {
    constructor() {
        super(...arguments);
        this.nativeView = undefined;
        this._isEnabled = false;
    }
    initNativeView() {
        this.nativeView = NSTableCellView.new();
        return this.nativeView;
    }
    addNativeChild(child) {
        if (child.nodeName === "IMAGE") {
            this.nativeView.imageView = child.nativeView;
        }
        else if (child.nodeName === "TEXT") {
            this.nativeView.textField = child.nativeView;
        }
        this.nativeView.addSubview(child.nativeView);
    }
    removeNativeChild(child) {
        if (child.nodeName === "IMAGE") {
            // @ts-expect-error imageView is nullable
            this.nativeView.imageView = null;
        }
        else if (child.nodeName === "TEXT") {
            // @ts-expect-error textField is nullable
            this.nativeView.textField = null;
        }
        child.nativeView?.removeFromSuperview();
    }
    getOwner() {
        let node = this.parentNode;
        while (node) {
            if (node.nodeName !== "TABLE-CELL") {
                break;
            }
            node = node.parentNode;
        }
        return node;
    }
};
__decorate([
    native({
        setNative: (view, key, value) => {
            if (value) {
                view.getOwner()?.selectCell?.(view);
            }
            else {
                if (view.getOwner()?.nativeView.selectedCell === view.nativeView) {
                    view.getOwner()?.selectCell(null);
                }
            }
        },
    }),
    __metadata("design:type", Boolean)
], TableCell.prototype, "selected", void 0);
TableCell = __decorate([
    view({
        name: "HTMLTableCellElement",
        tagName: "table-cell",
    })
], TableCell);
export { TableCell };
//# sourceMappingURL=table-cell.js.map